---
{{ template "common.ConfigMap" (list . "promtail.ConfigMap") }}

{{- define "promtail.ConfigMap" }}
metadata:
  name: {{ template "common.fullname" . }}-config
data:
  promtail.yaml: |
    server:
      http_listen_port: 3101

    clients:
      - url: http://loki.monitoring.svc:3100/loki/api/v1/push

    positions:
      filename: /tmp/positions.yaml

    scrape_configs:
      - job_name: loki_push_api
        loki_push_api:
          server:
            http_listen_address: 0.0.0.0
            http_listen_port: 3102

      - job_name: kubernetes
        kubernetes_sd_configs:
          - role: pod
        pipeline_stages:
          - cri: {}
        relabel_configs:
          - action: replace
            target_label: job
            replacement: kubernetes
          - action: replace
            source_labels:
              - __meta_kubernetes_node_name
            target_label: __host__
          - action: replace
            source_labels:
              - __meta_kubernetes_namespace
            target_label: namespace
          - action: replace
            source_labels:
              - __meta_kubernetes_pod_name
            target_label: pod
          - action: replace
            source_labels:
              - __meta_kubernetes_pod_container_name
            target_label: container
          - action: replace
            source_labels:
              - __meta_kubernetes_pod_uid
              - __meta_kubernetes_pod_container_name
            separator: /
            target_label: __path__
            replacement: /var/log/pods/*$1/*.log
{{- end }}
